Subject: Re: bug#78686: feature/igc: [PATCH] Make charset_table an exact root

From: Helmut Eller <[email-masked]>
Date: Thu, 05 Jun 2025 18:41:25 +0200

On Thu, Jun 05 2025, Pip Cet wrote:

[...]
>>> So let's get rid of that unnecessary root.
>
> I still think we should do that.  Do you think getting rid of the root
> would actually make things worse? 

Probably not.

[...]
>>> 1. undumped Emacs sessions.  I don't think these are worth optimizing
>>> for.  Do you?
>>
>> No. But there is also no need to make them gratuitously different from
>> normal sessions.
>
> I agree, but the decision has been made on the master branch to do just
> that (static storage pre-pdump; pdump storage post-pdump; xmalloc if
> grown), and if we want to revisit it we need to fix it on the master
> branch.

Sounds like the inmates are running the asylum :-)

[...]
>> Exactly: my patch copies the charset table to the place where it
>> belongs, the space in the BSS section reserved for it.  Just like
>> builtin symbols and subrs are copied to their space in the BSS section.
>
> I don't think those two special cases (lispsym has very good reasons for
> being special; subrs aren't in the BSS section) warrant introducing a
> third special case.

So subrs end up in the .subrs section.  Sill, subrs are copied back from
the dump.

[...]
>> I like my patch better.
>
> Okay.  Still, the first single-line patch would improve things, right?

Yes.  Still not as good as my approach.

Helmut